openapi: 3.0.0
info:
  title: VisibilityIQ WLAN Signal Strength
  version: 1.1.0
servers:
- url: https://api.zebra.com/v2/data/visibility/devices/utilization
  description: For US
- url: https://api.zebra.com/v2/eu/data/visibility/devices/utilization
  description: For EU
security:
- BearerAuth: []
- ApiKeyAuth: []
tags:
- name: WLAN Signal Strength
paths:
  /wlan/site-status:
    get:
      tags:
      - WLAN Site Status
      summary: Retrieves Site WLAN Signal Strength
      description: Retrieves WLAN signal strength information for sites for the last
        seven days
      operationId: Retrieve Site WLAN Signal Strength
      parameters:
      - name: companyName
        in: header
        description: Company name
        required: true
        schema:
          type: string
      - name: partnerName
        in: header
        description: Partner name
        required: true
        schema:
          type: string
      - name: offset
        in: query
        description: 'Pagination parameter indicating the starting record position
          for returning the results from the result set.  Any positive value is acceptable.
          An offset bigger than the number of available results will result in an
          error. A negative value will be replaced with 0. Normally, value should
          be 0 or a positive multiple of limit. '
        required: false
        schema:
          type: integer
          default: 0
      - name: limit
        in: query
        description: 'Pagination size indicating the maximum number of results to
          be returned in the response. Valid values are 1 to 20000. Values higher
          than 20000 will be replaced with 20000. Values less than 1 will be replaced
          with 250. '
        required: false
        schema:
          type: integer
          default: 250
      - name: wlanLowerThreshold
        in: header
        description: Signal strength in decibel milliwatts below which it will be
          considered poor. Any positive or negative value is acceptable. Default is
          -77. Less than the lower threshold will be categorized as poor.
        required: false
        style: simple
        explode: false
        schema:
          type: integer
      - name: wlanUpperThreshold
        in: header
        description: Signal strength in decibel milliwatts above which it will be
          considered excellent. Any positive or negative value is acceptable. Default
          is -65. Above the upper threshold will be categorized as excellent.
        required: false
        style: simple
        explode: false
        schema:
          type: integer
      responses:
        "200":
          description: Successful operation
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ApiResponse'
        "400":
          description: Bad request
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ApiError'
        "401":
          description: Unauthorized
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ApiError'
        "500":
          description: Internal server error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ApiError'
      deprecated: false
  /wlan/signal-strength:
    get:
      tags:
      - WLAN Signal Strength
      summary: Retrieve Device WLAN Signal Strength
      description: Retrieves WLAN signal strength information of devices for the last
        seven days.
      operationId: Retrieve Device WLAN Signal Strength
      parameters:
      - name: companyName
        in: header
        description: Company name
        required: true
        schema:
          type: string
      - name: partnerName
        in: header
        description: Partner name
        required: true
        schema:
          type: string
      - name: offset
        in: query
        description: 'Pagination parameter indicating the starting record position
          for returning the results from the result set.  Any positive value is acceptable.
          An offset bigger than the number of available results will result in an
          error. A negative value will be replaced with 0. Normally, value should
          be 0 or a positive multiple of limit. '
        required: false
        schema:
          type: integer
          default: 0
      - name: limit
        in: query
        description: 'Pagination size indicating the maximum number of results to
          be returned in the response. Valid values are 1 to 20000. Values higher
          than 20000 will be replaced with 20000. Values less than 1 will be replaced
          with 250. '
        required: false
        schema:
          type: integer
          default: 250
      - name: wlanLowerThreshold
        in: header
        description: Signal strength in decibel milliwatts below which it will be
          considered poor. Any positive or negative value is acceptable. Default is
          -77. Less than the lower threshold will be categorized as poor.
        required: false
        style: simple
        explode: false
        schema:
          type: integer
      - name: wlanUpperThreshold
        in: header
        description: Signal strength in decibel milliwatts above which it will be
          considered excellent. Any positive or negative value is acceptable. Default
          is -65. Above the upper threshold will be categorized as excellent.
        required: false
        style: simple
        explode: false
        schema:
          type: integer
      - name: siteName
        in: header
        description: 'Site Name for retrieving data of the specific site '
        required: true
        style: simple
        explode: false
        schema:
          type: string
      - name: sort
        in: header
        description: "Sort order for the results.  Specified as a JSON object. Currently,\
          \ only one sort order is supported in the criteria even though it is an\
          \ array. Elements other than the first one will be ignored currently.\n\
          \  {\n    \"criteria\": [\n      {\n        \"a\": \"signalStrengthBand\"\
          ,\n        \"o\": \"asc\"\n      }\n    ]\n  } "
        required: false
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/WlanSortCriteria'
      - name: filter
        in: header
        description: |-
          Filter based on column values. Numeric value will be filtered by an exact match.  Strings will be filtered by partial matches as well and are case insensitive matches.  The filter criteria are ANDed together. Date filters are also supported, but the value must match  the  format yyyy-MM-dd'T'HH:mm:ss'Z'. Start date and end date can not be lesser than a year. Example {
            "model": "XXXXX",
            "signalStrengthBand": "Good"
          }
        required: false
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/WlanFilterCriteria'
      responses:
        "200":
          description: Successful operation
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/DataGridApiResponse'
        "400":
          description: Bad request
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ApiError'
        "401":
          description: Unauthorized
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ApiError'
        "403":
          description: Forbidden
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ApiError'
        "500":
          description: Internal server error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ApiError'
      deprecated: false
components:
  schemas:
    DateTime:
      type: string
      format: date-time
    ApiResponse:
      type: object
      properties:
        status:
          $ref: '#/components/schemas/ApiResponseStatus'
        meta:
          $ref: '#/components/schemas/ApiResponseMeta'
        data:
          type: array
          items:
            oneOf:
            - $ref: '#/components/schemas/WlanSiteStatus'
        links:
          $ref: '#/components/schemas/ApiResponseLinks'
    DataGridApiResponse:
      type: object
      properties:
        status:
          $ref: '#/components/schemas/ApiResponseStatus'
        meta:
          $ref: '#/components/schemas/ApiResponseMeta'
        data:
          type: array
          items:
            oneOf:
            - $ref: '#/components/schemas/DeviceWlanSignalStrength'
        links:
          $ref: '#/components/schemas/ApiResponseLinks'
    ApiError:
      type: object
      properties:
        id:
          type: string
          description: A unique identifier for this particular occurrence of the problem
        links:
          type: object
          properties:
            about:
              type: string
              description: A link that leads to further details about this particular
                occurrence of the problem
          description: Links providing information related to this error
        status:
          type: integer
          description: The HTTP status code applicable to this problem
          format: int32
        code:
          type: string
          description: An application-specific error code, expressed as a string value
        title:
          type: string
          description: A short, human-readable summary of the problem that SHOULD
            NOT change from occurrence to occurrence of the problem, except for purposes
            of localization
        detail:
          type: string
          description: A human-readable explanation specific to this occurrence of
            the problem. Like title, this field’s value can be localized
        source:
          type: object
          properties:
            pointer:
              type: string
              description: A JSON Pointer [RFC6901] to the associated entity in the
                request document [e.g. "/data" for a primary data object, or "/data/attributes/title"
                for a specific attribute]
            parameter:
              type: string
              description: A string indicating which URI query parameter caused the
                error
          description: An object containing references to the source of the error
        meta:
          type: object
          description: A meta object containing non-standard meta-information about
            the error
    WlanSiteStatus:
      type: object
      properties:
        siteName:
          type: string
        poorDevicesCount:
          type: integer
        goodDevicesCount:
          type: integer
        excellentDevicesCount:
          type: integer
      example:
        siteName: 1125 XXXXXXX
        poorDevicesCount: 86
        goodDevicesCount: 324
        excellentDevicesCount: 212
    WlanSortCriteria:
      type: object
      properties:
        criteria:
          type: array
          items:
            type: object
            properties:
              a:
                type: string
                description: Attribute name
                enum:
                - assetName
                - signalStrength
                - fullModel
                - deviceType
                - model
                - signalStrengthBand
                - serialNum
                - siteHierarchy
                - siteName
                - companyName
                - bssid
                - accessPointName
                - reportedDatetime
              o:
                type: string
                description: Order for attribute values
                enum:
                - asc
                - desc
    WlanFilterCriteria:
      type: object
      properties:
        assetName:
          type: string
          description: Device full name
        signalStrength:
          type: integer
          description: WLAN signal strength
        fullModel:
          type: string
          description: Full device model number
        deviceType:
          type: string
          description: Device type
        model:
          type: string
          description: Model of the device
        signalStrengthBand:
          type: string
          description: WLAN signal strength band. Possible values poor, good and excellent
        serialNum:
          type: string
          description: Unique serial number of device
        siteHierarchy:
          type: string
          description: Site hierarchy of device
        siteName:
          type: string
          description: Name of the site that the device belongs to
        companyName:
          type: string
          description: Name of the company
        bssid:
          type: string
          description: Bssid of the access point
        accessPointName:
          type: string
          description: Friendly name of the access point
        reportedDatetime:
          $ref: '#/components/schemas/DateTime'
    DeviceWlanSignalStrength:
      type: object
      properties:
        assetName:
          type: string
          description: Device full name
        signalStrength:
          type: integer
          description: WLAN signal strength
        fullModel:
          type: string
          description: Full device model number
        deviceType:
          type: string
          description: Device type
        model:
          type: string
          description: Model of the device
        signalStrengthBand:
          type: string
          description: WLAN signal strength band. Possible values Poor, Good and Excellent
        serialNum:
          type: string
          description: Unique serial number of device
        siteHierarchy:
          type: string
          description: Site hierarchy of device
        siteName:
          type: string
          description: Name of the site that the device belongs to
        companyName:
          type: string
          description: Name of the company
        bssid:
          type: string
          description: Bssid of the access point
        accessPointName:
          type: string
          description: Friendly name of the access point
        reportedDatetime:
          $ref: '#/components/schemas/DateTime'
      example:
        accessPointName: Accesspoint Name
        assetName: XXXXXX_4083DEXX84XX
        signalStrengthBand: excellent
        bssid: 5c0e8b7f2033
        fullModel: TCXX-XXXXXX-XX
        companyName: Company Name
        model: XXXX
        deviceType: MOBILE COMPUTER
        serialNum: 15113XX14DXXXX
        siteHierarchy: company/region/country/timezome/state/sitename
        siteName: 677 XXXXXXC XX
        reportedDatetime: 2021-01-09T22:10:58Z
        signalStrength: -40
    ApiResponseStatus:
      type: integer
      description: The HTTP status code
      format: int32
    ApiResponseMeta:
      type: object
      properties:
        id:
          type: string
          description: A unique identifier for this request
        total:
          type: integer
          description: The total number of results
        offset:
          type: integer
          description: The offset used in this request
        limit:
          type: integer
          description: The effective limit used in this request
    ApiResponseLinks:
      type: object
      properties:
        self:
          type: string
          description: URL to this page
        first:
          type: string
          description: URL to the first page
        last:
          type: string
          description: URL to the last page
        prev:
          type: string
          description: URL to the previous page
        next:
          type: string
          description: URL to the next page
      description: Links for navigation. Only the applicable links are required to
        be present.
  responses:
    Response200:
      description: Successful operation
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/DataGridApiResponse'
    Response400:
      description: Bad request
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/ApiError'
    Response401:
      description: Unauthorized
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/ApiError'
    Response403:
      description: Forbidden
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/ApiError'
    Response500:
      description: Internal server error
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/ApiError'
  parameters:
    companyName:
      name: companyName
      in: header
      description: Company name
      required: true
      schema:
        type: string
    partnerName:
      name: partnerName
      in: header
      description: Partner name
      required: true
      schema:
        type: string
    offset:
      name: offset
      in: query
      description: 'Pagination parameter indicating the starting record position for
        returning the results from the result set.  Any positive value is acceptable.
        An offset bigger than the number of available results will result in an error.
        A negative value will be replaced with 0. Normally, value should be 0 or a
        positive multiple of limit. '
      required: false
      schema:
        type: integer
        default: 0
    limit:
      name: limit
      in: query
      description: 'Pagination size indicating the maximum number of results to be
        returned in the response. Valid values are 1 to 20000. Values higher than
        20000 will be replaced with 20000. Values less than 1 will be replaced with
        250. '
      required: false
      schema:
        type: integer
        default: 250
    wlanLowerThreshold:
      name: wlanLowerThreshold
      in: header
      description: Signal strength in decibel milliwatts below which it will be considered
        poor. Any positive or negative value is acceptable. Default is -77. Less than
        the lower threshold will be categorized as poor.
      required: false
      style: simple
      explode: false
      schema:
        type: integer
    wlanUpperThreshold:
      name: wlanUpperThreshold
      in: header
      description: Signal strength in decibel milliwatts above which it will be considered
        excellent. Any positive or negative value is acceptable. Default is -65. Above
        the upper threshold will be categorized as excellent.
      required: false
      style: simple
      explode: false
      schema:
        type: integer
  requestBodies: {}
  securitySchemes:
    BearerAuth:
      type: http
      scheme: bearer
    ApiKeyAuth:
      type: apiKey
      name: X-APIKey
      in: header
  links: {}
  callbacks: {}
